<?php
namespace Teknisa\PLA\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\DataSet;

class Dih52900PratoPorcionamento extends \Teknisa\GER\Services\CrudService {

	protected $dataSourceName = "mediprato";
	protected $dataSourceToSave = array();

	public function validaPorcionamentoMultiplo(DTO\Request $request, DTO\Response $response) {
		$this->dataSourceToSave = array();
		$row = (array)$request->getRow();

		for ($index = 0; $index < sizeof($row['CDPRATO']); $index++) {
			$conditions = $this->retornaCondicoesMediprato($row, $index);
			$filterCriteria = $this->getFilterCriteriaWithNrOrg(new FilterCriteria($this->dataSourceName, $conditions));
			$rows = $this->dataSourceManager->findBy($filterCriteria)->getRows();
			$this->pushDataSourceToSave($rows, $row, $index);
		}

		$dataSet = new DataSet($this->dataSourceName, $this->dataSourceToSave);
		$response->addDataSet($dataSet);
	}

	public function salvaPorcionamentoMultiplo(DTO\Request $request, DTO\Response $response) {
		$rows = $this->getRowsToSave($request, $this->dataSourceName);
		$this->save($this->dataSourceName, $rows);
	}

	private function retornaCondicoesMediprato($row, $index) {
		return array(
			array(
				"columnName" => "CDMEDICASE",
				"operator" => "=",
				"value" => $row["CDMEDICASE"]
				),
			array(
				"columnName" => "CDFILAUXPRAT",
				"operator" => "=",
				"value" => $row["CDFILAUXPRAT"][$index]
				),
			array(
				"columnName" => "CDPRATO",
				"operator" => "=",
				"value" => $row["CDPRATO"][$index]
				)
			);
	}

	private function pushDataSourceToSave($rows, $row, $index) {
		$newRow = array(
			"changed" => true,
			"CDMEDICASE" => $row["CDMEDICASE"],
			"CDFILAUXPRAT" => $row["CDFILAUXPRAT"][$index],
			"CDPRATO" => $row["CDPRATO"][$index],
			"VRPESOMED" => $row["VRPESOMED"],
			"IDMEDIDA" => $row["IDMEDIDA"]
			);
		$newRow["__is_new"] = empty($rows) ? true : false;
		$this->dataSourceToSave[] = $newRow;
	}
}