<?php
namespace Teknisa\PLA\Modules\Cardapio\Controllers;
/**
 * 01/06/2015
 * @author Francis
 */

use \Zeedhi\Framework\DTO\Request\Filter;
use \Zeedhi\Framework\DTO\Response;

class ConfigurarCardapio extends \Zeedhi\Framework\Controller\Simple {

	protected $configurarCardapio;
	protected $connection;

    public function __construct(\Teknisa\PLA\Modules\Cardapio\Services\ConfigurarCardapio $configurarCardapio, $connection) {
        $this->configurarCardapio = $configurarCardapio;
        $this->connection = $connection;
    }

    public function inserirConfiguracao($request, $response) {

		try {

			$parametros = $request->getFilterCriteria()->getConditions();

			$cdservfili = $parametros[0]['value'];
			$dtrefecnfmes = $parametros[1]['value'];
			$cdtipoprat = $parametros[2]['value'];
			$nrseqcnfmes = $parametros[3]['value'];
			$idopccnfmes = $parametros[4]['value'];
			$idimpcnfmes = $parametros[5]['value'];
			$idconcnfmes = $parametros[6]['value'];
			$dscompltpmes = $parametros[7]['value'] == "=" ? null : $parametros[7]['value'];
			$cdcontainer = $parametros[8]['value'] == "=" ? null : $parametros[8]['value'];
			$nrgrupoemb = $parametros[9]['value'] == "=" ? null : $parametros[9]['value'];
			$idreservamymenu = $parametros[10]['value'];
			$cdfilial = $parametros[11]['value'];

			$this->configurarCardapio->inserirConfiguracao($cdfilial, $cdservfili, $dtrefecnfmes, $cdtipoprat, $nrseqcnfmes, $idopccnfmes, $idimpcnfmes, $idconcnfmes, $dscompltpmes, $cdcontainer, $nrgrupoemb, $idreservamymenu);

		} catch(\Exception $e) {
			$response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }

    }

    public function alterarConfiguracao($request, $response) {

		try {

			$parametros = $request->getFilterCriteria()->getConditions();

			$cdservfili = $parametros[0]['value'];
			$dtrefecnfmes = $parametros[1]['value'];
			$nrseqcnfmes = $parametros[2]['value'];
			$idopccnfmes = $parametros[3]['value'];
			$idimpcnfmes = $parametros[4]['value'];
			$idconcnfmes = $parametros[5]['value'];
			$dscompltpmes = $parametros[6]['value'] == "=" ? null : $parametros[6]['value'];
			$cdcontainer = $parametros[7]['value'] == "=" ? null : $parametros[7]['value'];
			$nrgrupoemb = $parametros[8]['value'] == "=" ? null : $parametros[8]['value'];
			$idreservamymenu = $parametros[9]['value'];
			$cdfilial = $parametros[10]['value'];

			$this->configurarCardapio->alterarConfiguracao($cdfilial, $cdservfili, $dtrefecnfmes, $nrseqcnfmes, $idopccnfmes, $idimpcnfmes, $idconcnfmes, $dscompltpmes, $cdcontainer, $nrgrupoemb, $idreservamymenu);

		} catch(\Exception $e) {
			$response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }

    }

	public function apagarConfiguracao($request, $response) {

		try {
			$this->connection->beginTransaction();
			$parametros = $request->getFilterCriteria()->getConditions();

			$cdservfili = $parametros[0]['value'];
			$dtrefecnfmes = $parametros[1]['value'];
			$colunas = $parametros[2]['value'];
			$cdfilial = $parametros[3]['value'];

			foreach ($colunas as $coluna) {
				$this->configurarCardapio->apagarCardapio($cdfilial, $cdservfili, $dtrefecnfmes, $coluna['seq']);
			}
			$this->connection->commit();
		} catch(\Exception $e) {
			$this->connection->rollback();
			$response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }

	}

	public function atualizarConfiguracao($request, $response) {

		try {

			$parametros = $request->getFilterCriteria()->getConditions();

			$cdservfili = $parametros[0]['value'];
			$dtrefecnfmes = $parametros[1]['value'];
			$colunas = $parametros[2]['value'];
			$cdfilial = $parametros[3]['value'];
			foreach ($colunas as $coluna) {
				$this->configurarCardapio->atualizarCardapio($cdfilial, $cdservfili, $dtrefecnfmes, $coluna['de'], $coluna['para']);
			}

		} catch(\Exception $e) {
			$response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), $e->getCode()));
        }

	}

}